#@+leo
#@+node:0::@file ../scripts/docpart2docstring.py
#@+body
import re
from leoGlobals import *

docPart = re.compile("""^(@$|@ |@doc)(.*)$
^@c[ \t]*(.*?)$
^(def[ \t]*.*?:.*?)$
(.*)""", re.MULTILINE | re.DOTALL)


#@+others
#@+node:1::replaceDocPart
#@+body
def replaceDocPart(m):

	doc = m.group(2).strip()
	blanks = m.group(3).strip()
	if blanks: blanks += "\n\n"
	else: blanks = ""
	defLine = m.group(4)
	rest = m.group(5)
	docList = doc.split('\n')
	doc = string.join(docList,"\n\t")
	return blanks + defLine + '\n\n\t"""' + doc + '"""\n\n' + rest

#@-body
#@-node:1::replaceDocPart
#@+node:2::replaceDocParts
#@+body
def replaceDocParts(root=None):

	c = top()
	if not root: root = c.currentVnode()
	count = 0 ; found = 0 ; changed = 0
	v = root
	while v:
		s = v.bodyString()
		m = docPart.match(s)
		count += 1
		if m:
			found += 1
			s = replaceDocPart(m)
			if s:
				changed += 1
				#print ; print s
		v = v.threadNext()

	print "count, found, changed:", `count`,`found`,`changed`
#@-body
#@-node:2::replaceDocParts
#@-others


print __name__,

replaceDocParts()


#@-body
#@-node:0::@file ../scripts/docpart2docstring.py
#@-leo
